// Dialog.cpp
// Neuron Computing Inc.
#include "Toolkit.h"

#ifdef MOTIF
	#include <Xm\FileSB.h>
#else
#endif

extern XApp* g_app;

// Dialog
void Dialog::doModal()
{
	XtManageChild(m_w);
	while (!m_done)
	{
		XEvent an_event;
		XtAppNextEvent(g_app->m_appContext, &an_event);
		XtDispatchEvent(&an_event);
	}
}

// FileDialog
FileDialog::FileDialog()
{
}

FileDialog::~FileDialog()
{
}

void dialog_cancel(Widget widget,  XtPointer client_data, XtPointer call_data)
{
	Dialog* dlg = (Dialog*)client_data;
	dlg->m_done = TRUE;
}

void file_dialog_ok(Widget widget, XtPointer client_data, XtPointer call_data)
{
	FileDialog* dlg = (FileDialog*)client_data;
	XmFileSelectionBoxCallbackStruct* cbs =
				(XmFileSelectionBoxCallbackStruct*)call_data;
	char* filename = (char *) XmStringUnparse (cbs->value,
								XmFONTLIST_DEFAULT_TAG,
								XmCHARSET_TEXT,
								XmCHARSET_TEXT,
								NULL, 0, XmOUTPUT_ALL);
	if (filename != NULL)
	{
		strcpy(dlg->m_fileName, filename);
		XtFree(filename);
	}
	dlg->m_done = TRUE;
}

void FileDialog::create(Widget parent)
{
	Arg args[2];
	XtSetArg (args[0], XmNpathMode, XmPATH_MODE_RELATIVE);
	m_w = XmCreateFileSelectionDialog (parent, "filesb", args, 1);
	XtAddCallback (m_w, XmNcancelCallback, dialog_cancel, this);
	XtAddCallback (m_w, XmNokCallback, file_dialog_ok, this);
}
