// Widgets.h
// Neuron Computing Inc.
#ifndef __Widgets_h__
#define __Widgets_h__

#include "Toolkit.h"

#ifndef offsetof
#define offsetof(s,m)   ((size_t)((char*)&((s *)0)->m))
#endif

#define THIS(class_name, m) (class_name*)((char*)this - offsetof(class_name, m))

class ActionListener
{
public:
	virtual void actionPerformed(int id)=0;
};

// Label
class Label : public Component
{
public:
	void create(Widget parent);
	void setTitle(char* title);
};

// PushButton
class PushButton : public Component
{
public:
	int m_id;
	ActionListener* m_l;
public:
	PushButton();
	void create(Widget parent);
	void setTitle(char* title);
	void addActionListener(ActionListener* l);
};

// TextField
class TextField : public Component
{
public:
	void create(Widget parent);
};

#endif
